/*
 *
 *
 *
 */
#include "sim.h"

unsigned int get_cntr(void) { return curdsp.sequencer.cntr; }
void set_cntr(unsigned int new) 
{ 
  if (curdsp.sequencer.cntr) /* do not push if theres nothing to push */
    count_push();
  curdsp.sequencer.cntr = new; 
}

int count_push(void)
{
  if (curdsp.sequencer.count_stack_len >= 4)
    {
      fprintf(stderr, "count_push: count stack overflow!\n");
      set_sstat(get_sstat()|SSTAT_COUNT_OVERFLOW);
      return -1;
    }
  else if (curdsp.sequencer.sstat & SSTAT_COUNT_EMPTY)
    set_sstat(get_sstat()^SSTAT_COUNT_EMPTY);
  curdsp.sequencer.count_stack[curdsp.sequencer.count_stack_len].addr = curdsp.sequencer.cntr;
  return ++curdsp.sequencer.count_stack_len;
}

unsigned int count_pop(void)
{
  if (!curdsp.sequencer.count_stack_len)
    return curdsp.sequencer.cntr;
  curdsp.sequencer.count_stack_len--;
  curdsp.sequencer.cntr = curdsp.sequencer.count_stack[curdsp.sequencer.count_stack_len].addr;
  curdsp.sequencer.count_stack[curdsp.sequencer.count_stack_len].addr = 0x0000;
  if (!curdsp.sequencer.count_stack_len)
    set_sstat(get_sstat()|SSTAT_COUNT_EMPTY);
  return curdsp.sequencer.cntr;
}

void count_dump(void)
{
  int i;
  fprintf(stderr, "count_dump: --- Count Stack (%2d of 4 filled) ---\n", curdsp.sequencer.count_stack_len);
  fprintf(stderr, "count_dump:\tcntr = %04x\n", curdsp.sequencer.cntr);
  for (i=curdsp.sequencer.count_stack_len-1;i>=0;i--)
    fprintf(stderr, "count_dump:\t %2d\t%06x\n", i, curdsp.sequencer.count_stack[i].addr);
  fprintf(stderr, "count_dump: ----------------------------------\n");
  return;
}

void count_zero(void)
{
  curdsp.sequencer.count_stack_len = 0;
  memset(curdsp.sequencer.count_stack, 0, sizeof(struct count_stack_entry_s)*4);
  return;
}
